#define CATCH_CONFIG_MAIN
#include "catch2/catch.hpp"
#include <util/lr_classifier.h>

TEST_CASE("One vs All") {
  /* Basic check for one vs all classifier */
  int8_t w[] = {
      34, 33,
      -37, -35,
      -123, -125,
      126, 127
  };

  int32_t b[] = {17107,   54214,   62230, -133552};

  uint16_t x[] = {
      511, 511,
      511, 511,
      511, 511,
      511, 511,
      511, 511,
      511, 511,
      511, 511,
      511, 511,
      511, 511,
      511, 511,
      511, 511,
      84, 90,
      89, 90,
      89, 90,
      89, 90,
      89, 90,
      89, 90,
      89, 90,
      89, 90,
      89, 90,
      89, 90,
      0, 0,
      0, 0,
      0, 0,
      0, 0,
      0, 0,
      0, 0,
      0, 0,
      0, 0,
      0, 0,
      0, 0,
      0, 0,
      0, 0,
      1023, 1023,
      1023, 1023,
      1023, 1023,
      1020, 1022,
      1023, 1023,
      1023, 1023,
      1023, 1023,
      1023, 1023,
      1023, 1023,
      1023, 1023,
      1023, 1023
  };
  std::vector<uint8_t> y_expected{
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2,
      2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3
  };

  std::vector<uint8_t> y_output{};

  for (int i = 0; i < 44; ++i) {
    y_output.push_back(lr_classify(2, 4, w, b, &x[i*2]));
  }

  CHECK(y_expected == y_output);

}